#pragma semicolon 1
#pragma newdecls required
#pragma tabsize 0

#include <sourcemod>
#include <clientprefs>
#include <smokecolors>
#include <vip_core>

int cfg_iSmokeSize, cfg_iSmokeType;
char g_sConfig[PLATFORM_MAX_PATH];
KeyValues g_kConfig;

public Plugin myinfo =
{
	name	= "[VIP] Colored Smoke",
	version	= "1.0.1",
	author	= "Tomiks(vk.com/tomiksofficial) | Credits: iLoco#7631"
};

static const char g_sFeature[][] = {"ColoredSmoke", "SmokeColor"};

Handle g_hCookie, g_hCookie2;

bool g_bClientSay[MAXPLAYERS+1], g_bEnableSmoke[MAXPLAYERS+1];

float g_fClientRGB[MAXPLAYERS+1][3];

Menu ColoredSmokeMenu;

public void VIP_OnVIPLoaded()
{
    VIP_RegisterFeature(g_sFeature[0], BOOL, SELECTABLE, OnToggleItem, OnDisplayItem1);
    VIP_RegisterFeature(g_sFeature[1], VIP_NULL, SELECTABLE, OnSelectItem, OnDisplayItem, OnDrawItem);
}

public void CVarChanged_Type(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	cfg_iSmokeType = cvar.IntValue;
}

public void CVarChanged_Size(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	cfg_iSmokeSize = cvar.IntValue;
}

void CreateConfig()
{
    if(!g_kConfig.ImportFromFile(g_sConfig))
	{
		g_kConfig.JumpToKey("Colors", true);
            g_kConfig.SetString("Синий", "0 0 255");
            g_kConfig.SetString("Зелёный", "0 255 0");
            g_kConfig.SetString("Красный", "255 0 0");
		g_kConfig.Rewind();
		g_kConfig.ExportToFile(g_sConfig);
	}
}

void CreateMenuVip()
{
    char sColor[32], sSectionName[64];
    ColoredSmokeMenu = new Menu(MenuHandler_Colors);
    ColoredSmokeMenu.SetTitle("Выбор цвета дыма");

    ColoredSmokeMenu.AddItem("", "Указать цвет(чат)");

    g_kConfig.Rewind();
    if(g_kConfig.JumpToKey("Colors", false) && g_kConfig.GotoFirstSubKey(false))
    {
        do
        {
            g_kConfig.GetSectionName(sSectionName, sizeof(sSectionName));
            g_kConfig.GetString(NULL_STRING, sColor, sizeof(sColor));
            ColoredSmokeMenu.AddItem(sColor, sSectionName);
        } while(g_kConfig.GotoNextKey(false));
    }

    ColoredSmokeMenu.ExitBackButton = false;
    ColoredSmokeMenu.ExitButton = true;

    delete g_kConfig;
}

public void OnPluginStart()
{
    BuildPath(Path_SM, g_sConfig, sizeof(g_sConfig), "data/vip/modules/vip_colored_smoke_colors.ini");
    g_kConfig = new KeyValues("VIP_COLORED_SMOKE");
    CreateConfig();
    CreateMenuVip();

    g_hCookie = RegClientCookie("VIP_ColoredSmoke", "VIP_ColoredSmoke", CookieAccess_Public); // вкл выкл
    g_hCookie2 = RegClientCookie("VIP_SmokeColor", "VIP_SmokeColor", CookieAccess_Public); // цвет
    HookEventEx("smokegrenade_detonate", Event_SmokeDetonate, EventHookMode_Pre);

    LoadTranslations("vip_modules.phrases");

    ConVar cvar;
    (cvar = CreateConVar("sm_vip_smoke_type", "2", "Вневшний вид дыма. 1 - качественный(забирает больше фпс) ; 2 - менее качественный(забирает меньше фпс)")).AddChangeHook(CVarChanged_Type);
    cfg_iSmokeType = cvar.IntValue;

    (cvar = CreateConVar("sm_vip_smoke_size", "3", "Размер дыма. 1 - большой дым; 2 - средний дым; 3 - дым приближённый к стандартному")).AddChangeHook(CVarChanged_Size);
    cfg_iSmokeSize = cvar.IntValue;

    AutoExecConfig(true, "vip_smoke_colors", "vip");

    if(VIP_IsVIPLoaded())
    {
        VIP_OnVIPLoaded();
    }
}

public bool OnToggleItem(int iClient, const char[] szFeature)
{
	if(g_bEnableSmoke[iClient])
    {
        g_bEnableSmoke[iClient] = false;
        SetClientCookie(iClient, g_hCookie, "0");
        PrintToChat(iClient, "Цветной дым выключен");
    } else {
        g_bEnableSmoke[iClient] = true;
        SetClientCookie(iClient, g_hCookie, "1");
        PrintToChat(iClient, "Цветной дым включен");
    }

	return true;
}

public bool OnDisplayItem1(int iClient, const char[] szFeature, char[] szDisplay, int iMaxLength)
{
    if(VIP_IsClientFeatureUse(iClient, szFeature)) // Проверяем что функция включена у игрока
    {
        char sBuffer[4];
        GetClientCookie(iClient, g_hCookie, sBuffer, sizeof(sBuffer));
        int iEnable = StringToInt(sBuffer);
        if(iEnable)
        {
            FormatEx(szDisplay, iMaxLength, "%T [+]", szFeature, iClient);

            return true;
        } else {
            FormatEx(szDisplay, iMaxLength, "%T [-]", szFeature, iClient);

            return true;
        }
    }

    return false;
}

public bool OnDisplayItem(int iClient, const char[] szFeature, char[] szDisplay, int iMaxLength)
{
    if(VIP_IsClientFeatureUse(iClient, g_sFeature[0]) && VIP_GetClientFeatureBool(iClient, g_sFeature[0])) // Проверяем что функция включена у игрока
    {
        FormatEx(szDisplay, iMaxLength, "%T", g_sFeature[1], iClient);
        return true;
    }

    return false;
}

public bool OnSelectItem(int iClient, const char[] szFeature)
{
    // char sColor[32], sSectionName[64];
    // Menu menu = new Menu(MenuHandler_Colors);
    // menu.SetTitle("Выбор цвета дыма");

    // menu.AddItem("", "Указать цвет(чат)");

    // g_kConfig.Rewind();
    // if(g_kConfig.JumpToKey("сolors", false) && g_kConfig.GotoFirstSubKey(false))
    // {
    //     do
    //     {
    //         PrintToConsoleAll("ЦИКЛ");
    //         g_kConfig.GetSectionName(sSectionName, sizeof(sSectionName));
    //         g_kConfig.GetString(NULL_STRING, sColor, sizeof(sColor));
    //         menu.AddItem(sColor, sSectionName);
    //     } while(g_kConfig.GotoNextKey(false));
    // }

    // menu.ExitBackButton = false;
    // menu.ExitButton = true;
    ColoredSmokeMenu.Display(iClient, MENU_TIME_FOREVER);

    return false;
}

public int OnDrawItem(int iClient, const char[] szFeature, int iStyle)
{
    if(VIP_IsClientFeatureUse(iClient, g_sFeature[0]) && VIP_GetClientFeatureBool(iClient, g_sFeature[0]))
    {
        if(!g_bEnableSmoke[iClient])
        {
            return ITEMDRAW_DISABLED;
        }
    }

    return iStyle;
}

public Action OnClientSayCommand(int iClient, const char[] sCommand, const char[] iArgs)
{
	if(g_bClientSay[iClient])
	{
        char sBuffer[3][16];
        ExplodeString(iArgs, " ", sBuffer, 3, 16);

        float rgb[3];
        rgb[0] = StringToFloat(sBuffer[0]);
        rgb[1] = StringToFloat(sBuffer[1]);
        rgb[2] = StringToFloat(sBuffer[2]);

        if(rgb[0] <= 255.0 && rgb[1] <= 255.0 && rgb[2] <= 255.0)
        {
            g_fClientRGB[iClient][0] = rgb[0];
            g_fClientRGB[iClient][1] = rgb[1];
            g_fClientRGB[iClient][2] = rgb[2];
            SetClientCookie(iClient, g_hCookie2, iArgs);

            PrintToChat(iClient, "Цвет успешно установлен");
        } else {
            PrintToChat(iClient, "Указан неверный цвет");
        }
        g_bClientSay[iClient] = false;
        return Plugin_Handled;
    }

    return Plugin_Continue;
}

public void OnClientPostAdminCheck(int iClient)
{
    OnClientCookiesCached(iClient);
}

public void OnClientCookiesCached(int iClient)
{
    char sBuffer[64];
    GetClientCookie(iClient, g_hCookie, sBuffer, sizeof(sBuffer));

    if(sBuffer[0])
    {
        g_bEnableSmoke[iClient] = view_as<bool>(StringToInt(sBuffer));
    } else {
        SetClientCookie(iClient, g_hCookie, "0");
    }

    GetClientCookie(iClient, g_hCookie2, sBuffer, sizeof(sBuffer));

    if(sBuffer[0])
    {
        char sExplodeString[3][16];
        ExplodeString(sBuffer, " ", sExplodeString, 3, 16);
        g_fClientRGB[iClient][0] = StringToFloat(sExplodeString[0]);
        g_fClientRGB[iClient][1] = StringToFloat(sExplodeString[1]);
        g_fClientRGB[iClient][2] = StringToFloat(sExplodeString[2]);
    } else {
        SetClientCookie(iClient, g_hCookie2, "94 95 94");
        g_fClientRGB[iClient][0] = 94.0;
        g_fClientRGB[iClient][1] = 95.0;
        g_fClientRGB[iClient][2] = 94.0;
    }
}

public void OnClientDisconnect(int iClient)
{
    g_bClientSay[iClient] = false;
    g_bEnableSmoke[iClient] = false;
}

public int MenuHandler_Colors(Menu menu, MenuAction action, int iClient, int item)
{
    switch(action)
    {
        case MenuAction_Select:
        {
            switch(item)
            {
                case 0:
                {
                    g_bClientSay[iClient] = true;
                    PrintToChat(iClient, "Напиши в чат цвет RGB(Пример: 255 255 255)");
                }
                default:
                {
                    char sBuffer[32], sExplodeString[3][16];
                    menu.GetItem(item, sBuffer, sizeof(sBuffer));

                    ExplodeString(sBuffer, " ", sExplodeString, 3, 16);
                    g_fClientRGB[iClient][0] = StringToFloat(sExplodeString[0]);
                    g_fClientRGB[iClient][1] = StringToFloat(sExplodeString[1]);
                    g_fClientRGB[iClient][2] = StringToFloat(sExplodeString[2]);
                    SetClientCookie(iClient, g_hCookie2, sBuffer);

                    PrintToChat(iClient, "Установлен новый цвет");
                }
            }
        }
    }
}

public Action Event_SmokeDetonate(Event hEvent, const char[] name, bool dontBroadcast)
{
    int iClient = GetClientOfUserId(hEvent.GetInt("userid"));
    if(VIP_IsClientVIP(iClient) && VIP_GetClientFeatureBool(iClient, g_sFeature[0]) && g_bEnableSmoke[iClient])
    {
        int iEnt = hEvent.GetInt("entityid");
        float fPos[3];
        fPos[0] = hEvent.GetFloat("x");
        fPos[1] = hEvent.GetFloat("y");
        fPos[2] = hEvent.GetFloat("z");
        SC_CreateCustomSmoke3(fPos, g_fClientRGB[iClient], iEnt);
    }
}

public void OnPluginEnd()  // Плагин остановлен
{
    if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available) // Если ядро VIP еще запущено
    {
        VIP_UnregisterFeature(g_sFeature[0]); // Удаляем ф-ю
        VIP_UnregisterFeature(g_sFeature[1]); // Удаляем ф-ю
    }
}